<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php";
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning_resources . 'lib/task_schedule/task_scheduler_functions.php';
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';


use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
$postdata = json_decode(file_get_contents("php://input"), true);

checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) || !checkIfIssetAndNotEmpty($postdata['institution_id']) ||
    // !isset($postdata['branch_id']) || !checkIfIssetAndNotEmpty($postdata['branch_id']) ||
    !isset($postdata['activity_mentor_id']) || !checkIfIssetAndNotEmpty($postdata['activity_mentor_id']) ||
    !isset($postdata['api_signature']) || !checkIfIssetAndNotEmpty($postdata['api_signature']) ||
    !isset($postdata['function_type']) || !checkIfIssetAndNotEmpty($postdata['function_type']) ||
    !isset($postdata['jwt_token']) || !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

// $institution_id = $postdata['institution_id'];
// $branch_id = $postdata['branch_id'];

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';
require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

$academic_id = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if ($academic_id == false) {
    errorreturn("Access denied. Academic session not active.");
}

if ($postdata['function_type'] == 'delete_activity_mentor') {
    // Ensure activity_mentor_id is provided
    if (empty($postdata['activity_mentor_id'])) {
        errorreturn("Activity mentor ID is required for deletion.");
    }

    $activity_mentor_id = $postdata['activity_mentor_id'];

    // Check if the activity mentor exists based on activity_mentor_id
    $check_activity_mentor_sql = "SELECT id FROM activity_mentor WHERE id = ? AND institution_id = ? ";
    $stmt = $conn_rjllearning_specific->prepare($check_activity_mentor_sql);
    $stmt->execute([$activity_mentor_id, $institution_id]);

    $existing_activity_mentor = $stmt->fetch(PDO::FETCH_ASSOC);

    if ($existing_activity_mentor) {
        
        // Delete the existing activity mentor
        
        $activity_delete = delete_Activity($activity_mentor_id, $conn_rjllearning_specific, $s3_learning_bucket, $bucket_name, $institution_id);
        
        manageSchedulerTask($conn_rjllearning, $workspace_id, $institution_id, 'activity', $activity_mentor_id, null, null, 1, $process_type = 'delete');
        
        successreturn("Successfully deleted activity mentor.");
    } else {
        errorreturn("Activity mentor ID does not exist.");
    }
}
